COMMENT ^
This program shows how to dock a popup window to a main window
Version 1.2

; #########################################################################^
      .386                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive
; #########################################################################      
      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\comctl32.inc
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\comctl32.lib   
; #########################################################################
      WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
      WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
      CreateMyPopWin PROTO:DWORD,:DWORD,:DWORD,:DWORD,:DWORD  
      WndProc4MyPopup PROTO  :DWORD,: DWORD,: DWORD,: DWORD
      DockSideWindow PROTO :Dword
      DockWindow2 PROTO :Dword
; #########################################################################   
     FileMENU			EQU	600     ;These menu constants are copied from the resource file
     CM_FILEEXIT     	EQU 102
     CM_HelpAbout		EQU 107
     CM_Show			EQU 108
     CM_Hide			EQU 109
.data
	szAppName           db "Main Window",0
    szClassName         db "BasicClass",0
	szPopUpClassName    db "PopupWindowClass",0
	szAboutText         db "Docking Window demonstration",0
	szPopUpWinCaption   db "Popup Window",0
	CommandLine         dd 0
	hMainWnd            dd 0
	hPopupWnd           dd 0
	hInstance           dd 0
	
.code
; #########################################################################
start:
    invoke GetModuleHandle, NULL 
    mov hInstance, eax
    invoke GetCommandLine           
    mov CommandLine, eax
    invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT 
    invoke ExitProcess,eax       

; #########################################################################
WinMain proc hInst:DWORD, hPrevInst :DWORD, CmdLine:DWORD, CmdShow:DWORD

        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG
        LOCAL Wwd  :DWORD       ;Window width
        LOCAL Wht  :DWORD       ;Window height
        LOCAL Wtx  :DWORD
        LOCAL Wty  :DWORD
        
        LOCAL PopWwd    :DWORD  ;Pop up window parameters
        LOCAL PopWht    :DWORD
        LOCAL PopX      :DWORD
        LOCAL PopY      :DWORD
                
        ; --------Fill WNDCLASSEX structure with required variables----------
        
        mov  wc.cbSize,         sizeof WNDCLASSEX
        mov  wc.style,          CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
        mov  wc.lpfnWndProc,    offset WndProc      ; address of WndProc
        mov  wc.cbClsExtra,     NULL
        mov  wc.cbWndExtra,     NULL
        push hInst
        pop  wc.hInstance
        mov  wc.hbrBackground,  COLOR_BTNFACE+1     ; system color
        mov  wc.lpszMenuName,   NULL
        mov  wc.lpszClassName,  offset szClassName  ; window class name
        invoke LoadIcon,hInst,500                ; icon ID - resource icon
        mov  wc.hIcon,          eax
        invoke LoadCursor,NULL,IDC_ARROW         ; system cursor
        mov  wc.hCursor,        eax
        mov  wc.hIconSm,        0

        invoke RegisterClassEx, ADDR wc            ; register the window class

        mov  Wtx,200                        
        mov  Wty,200
        mov  Wwd,200                               ;Initialise window width to 600 pixels
        mov  Wht,200                               ;Initialise window height to 400 pixels
        
        invoke CreateWindowEx,WS_EX_LEFT+WS_EX_DLGMODALFRAME, ADDR szClassName, ADDR szAppName,
                              WS_OVERLAPPEDWINDOW, Wtx,Wty,Wwd,Wht,
                              NULL,NULL, hInst,NULL
                              
        mov  hMainWnd,eax                         ; copy return value into handle DWORD
        invoke LoadMenu,hInst,600                 ; load resource menu
        invoke SetMenu,hMainWnd,eax               ; set it to main window
        invoke ShowWindow,hMainWnd,SW_SHOWNORMAL  ; display the window
        invoke UpdateWindow,hMainWnd              ; update the display


        mov  PopWwd,    200     ;Set popup width
        mov  PopWht,    200		;Set popup Height
        mov  PopX,      400		;Set popup X Position
        mov  PopY,      200		;Set popup Y Position
        invoke CreateMyPopWin, PopX, PopY, PopWwd, PopWht, hInstance ;create popup

 ;============== Loop until PostQuitMessage is sent ===================    

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0         ; get each message
      cmp eax, 0                                  ; exit if GetMessage()
      je ExitLoop                                 ; returns zero
      invoke TranslateMessage, ADDR msg           ; translate it
      invoke DispatchMessage,  ADDR msg           ; send it to message proc
      jmp StartLoop     
    ExitLoop:
      mov eax, msg.wParam
      ret
      
WinMain endp

; #########################################################################

WndProc proc hWin: DWORD, uMsg: DWORD, wParam: DWORD, lParam: DWORD
    .if uMsg == WM_COMMAND

  
        ;======== menu commands ========

        .if wParam == 102   ; Exit command on file menu
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL
            
        .elseif wParam == 106  ; About command on menu            
            invoke MessageBox,hWin,ADDR szAboutText,ADDR szAppName,MB_OK

        .elseif wParam==CM_Show  ;Show popup

            invoke ShowWindow,hPopupWnd,SW_SHOWNORMAL  	;display the popup window
            invoke UpdateWindow,hPopupWnd              	;update the display

        .elseif wParam==CM_Hide                     	;Hide popup window
            invoke ShowWindow,hPopupWnd,SW_HIDE

        ;====== end menu commands ======
        .endif
          
    .elseif uMsg == WM_DESTROY

   
        invoke PostQuitMessage,NULL
        mov eax,0
        ret
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ret
WndProc endp
; #########################################################################


WndProc4MyPopup proc hWin: DWORD, uMsg: DWORD, wParam: DWORD, lParam: DWORD

    .if uMsg == WM_WINDOWPOSCHANGING  
		invoke DockSideWindow, lParam	;lparam points to a WindowPos structure
		invoke DockWindow2, lParam		;lparam points to a WindowPos structure		
    .else
    	invoke DefWindowProc,hWin,uMsg,wParam,lParam
    .endif
    ret
    
WndProc4MyPopup endp

CreateMyPopWin Proc PopX:DWORD, PopY:DWORD, PopWwd:DWORD, PopWht :DWORD, WinMainProcInst:DWORD  
    ; -------------------------------------------------------------------------------
    ; Creates and registers a new popup window 
    ;
    ; Uses globals:         szPopUpClassName
    ;                       szPopUpWinCaption
    ;                       hPopupWnd
    ; Parameters:           PopX - x co-ordinate of popup
    ;                       PopY - y co-ordinate of popup
    ;                       PopWwd - Width of popup window in screen coordinates
    ;                       PopWht - Height of popup window in screen coordinates
    ;                       WinMainProcInst - HInst parameter of WinMain proc
    ; ------------------------------------------------------------------------------- 

        LOCAL pwc   :WNDCLASSEX

        ; -------- Fill Popup WNDCLASSEX structure with required variables ----------

        mov  pwc.cbSize,         sizeof WNDCLASSEX
        mov  pwc.style,          CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW or CS_NOCLOSE
        mov  pwc.lpfnWndProc,    offset WndProc4MyPopup      ; address of WndProc4MyPopup
        mov  pwc.cbClsExtra,     NULL
        mov  pwc.cbWndExtra,     NULL
        push WinMainProcInst
        pop  pwc.hInstance
        mov  pwc.hbrBackground,  COLOR_BTNFACE+1     ; system color
        mov  pwc.lpszMenuName,   NULL
        mov  pwc.lpszClassName,  offset szPopUpClassName  ; window class name
        invoke LoadIcon,WinMainProcInst,500                ; icon ID - resource icon
        mov  pwc.hIcon,          eax
        invoke LoadCursor,NULL,IDC_ARROW         ; system cursor
        mov  pwc.hCursor,        eax
        mov  pwc.hIconSm,        0

        invoke RegisterClassEx, ADDR pwc            ; register the window class

        ; --------Create and register Popup window ----------

        invoke CreateWindowEx,WS_EX_LEFT, ADDR szPopUpClassName, ADDR szPopUpWinCaption,        
                              WS_POPUP or WS_BORDER or WS_CAPTION,                             
                              PopX,PopY,PopWwd,PopWht, hMainWnd,NULL, WinMainProcInst,NULL
        mov  hPopupWnd,eax  
        mov eax,0
        ret
CreateMyPopWin endP
; #########################################################################

DockSideWindow proc uses edi ecx, ptrSecondWindowPos:Dword
; ********************************************************************************************************************
; PURPOSE: This procedure docks a window or dialog box to the side of the main window
;           
; USE: 	This procedure is called by the following code which should be placed in the callback procedure
;		for the second window: 
;		.elseif uMsg == WM_WINDOWPOSCHANGING
;			invoke DockWindow, lParam	;lparam points to a WindowPos structure
;
; ON ENTRY: ptrSecondWindowPos is an lParam pointer to a WindowPos structure for the second window
;			
; USES:     hMainWnd - the handle of the main window
;           
; NOTE:     Adapted from a program written by Donkey for GoASM
;             
; ********************************************************************************************************************

	LOCAL MainWinRect : RECT
	    
	invoke GetWindowRect, hMainWnd, ADDR MainWinRect    ;get main window co-ords in MainWinRect: left,top,right,bottom
	mov edi,ptrSecondWindowPos			;edi holds address of a WindowPos Structure for the 2nd window
										;compare the tops to see if they are close enough
	mov eax,[edi+WINDOWPOS.y]			;Get top edge of second window
	sub eax,[MainWinRect.top]			;Sub top edge of main window
	jns @F                              ;if result in eax is negative
	neg eax                    		    ;then make eax positive
@@:	
	cmp eax,10                          ;are the tops of each window more than 10 pixels apart?
	jg EndDocking                       ;If so, jump to EndDocking
	
	mov ecx,[MainWinRect.right]			;Get right edge of main window
	sub ecx,[edi+WINDOWPOS.x]			;Sub left edge of second window
	jns @F								;if result in eax is negative
	neg ecx                             ;then make eax positive
@@:
	cmp ecx,10							;are the sides greater than 10 pixels apart on the right side of main window?
	jg CheckLeft						;No - Check left side of main window
										;YES - Dock the window to the right edge of the main window
	mov eax,[MainWinRect.right]			;Get the right co-ord of the main window
	mov [edi+WINDOWPOS.x],eax			;Store it in the left edge value of WindowPos for secondary window
	mov eax,[MainWinRect.top]			;Get the top co-ord of the main window
	mov [edi+WINDOWPOS.y],eax			;Store it in the top edge value of WindowPos for secondary window
	jmp EndDocking						;exit
	
CheckLeft:		
	mov eax,[edi+WINDOWPOS.x] 			;Get left edge of secondary window
	add eax,[edi+WINDOWPOS.lx]			;add width of secondary window to this value (=right edge)
	mov ecx,[MainWinRect.left]			;Get left co-ord of main window
	sub ecx,eax							;subtract left co-ordinates of each window
	jns @F								;if result in eax is negative
	neg ecx                             ;then make eax positive
@@:
	cmp ecx,10							;are the sides greater than 10 pixels apart on the left side of main window?
	jg EndDocking						;if not, exit
										;else Dock the window to the left edge of the main window 
	mov eax,[MainWinRect.left]			;Get left co-ord of main window
	sub eax,[edi+WINDOWPOS.lx]			;sub width of secondary window from this value  (=left edge for 2nd window)
	mov [edi+WINDOWPOS.x],eax			;set left co-ord of second window
	mov eax,[MainWinRect.top]			;get top co-ord of main window
	mov [edi+WINDOWPOS.y],eax			;set top co-ord of second window
EndDocking:
	ret

DockSideWindow endp

DockWindow2 proc uses edi ecx, ptrSecondWindowPos:Dword
; ********************************************************************************************************************
; PURPOSE: This procedure docks a window or dialog box above or below the main window
;           
; USE: 	This procedure is called by the following code which should be placed in the callback procedure
;		for the second window: 
;		.elseif uMsg == WM_WINDOWPOSCHANGING
;			invoke DockWindow2, lParam	;lparam points to a WindowPos structure for the 2nd window
;
; ON ENTRY: ptrSecondWindowPos is an lParam pointer to a WindowPos structure for the second window
;			
; USES:     hMainWnd - the handle of the main window
;           
; NOTE:     Adapted from the DockWindow procedure above
;             
; ********************************************************************************************************************

	LOCAL MainWinRect : RECT
	    
	invoke GetWindowRect, hMainWnd, ADDR MainWinRect    ;get main window co-ords int MainWinRect: left,top,right,bottom
	mov edi,ptrSecondWindowPos			;ediholds address of a WindowPos Structure for the 2nd window

	;are left edges of the windows within 10 pixels of each other?	
	mov ecx,[MainWinRect.left]			;Get left edge of main window
	sub ecx,[edi+WINDOWPOS.x]			;Sub left edge of second window
	jns @F								;if result in ecx is negative
	neg ecx                             ;then make ecx positive
@@:
	cmp ecx,10							;are the left edges greater than 10 pixels apart?
	jg EndDocking						;Yes - end docking procedure	
	
	;is top of second window within 10 pixels of lower edge of main window?
	mov eax,[edi+WINDOWPOS.y]			;Get top edge of second window
	sub eax,[MainWinRect.bottom]		;Sub bottom edge of main window
	jns @F                              ;if result in eax is negative
	neg eax                    		    ;then make eax positive
@@:	
	cmp eax,10                          ;is top of 2nd window more than 10 pixels from bottom of main window?
	jg CheckMainTop                     ;If not, check edges at top of main window
										;YES - Dock the window at bottom of main window
	mov eax,[MainWinRect.bottom]		;Get the bottom co-ord of the main window
	mov [edi+WINDOWPOS.y],eax			;Store it in the top edge value of WindowPos for secondary window
	mov eax,[MainWinRect.left]			;Get the left co-ord of the main window
	mov [edi+WINDOWPOS.x],eax			;Store it in the left edge value of WindowPos for secondary window
	jmp EndDocking						;exit

CheckMainTop:
	;is bottom edge of second window within 10 pixels of top edge of main window?
	mov eax,[edi+WINDOWPOS.y] 			;Get top edge of secondary window
	add eax,[edi+WINDOWPOS.cy]			;add height of secondary window to this value (=bottom edge)
	mov ecx,[MainWinRect.top]			;Get top co-ord of main window
	sub ecx,eax							;subtract co-ordinates of each window
	jns @F								;if result in eax is negative
	neg ecx                             ;then make ecx positive
@@:
	cmp ecx,10                          ;are the edges of each window more than 10 pixels apart?	
	jg EndDocking                       ;If so, jump to EndDocking
										;else Dock the window at the top of the main window
	mov eax,[MainWinRect.left]			;Get left co-ord of main window	
	mov [edi+WINDOWPOS.x],eax			;set left co-ord of second window
	
	mov eax,[MainWinRect.top]			;get top co-ord of main window
	sub eax,[edi+WINDOWPOS.cy]			;sub height of second window
	mov [edi+WINDOWPOS.y],eax			;set top co-ord of second window
EndDocking:
	ret
DockWindow2 endp
end start

